import logging

from search.search import query_index, add_to_index
from webapp import db as DB


class SearchableMixin(object):
    @classmethod
    def search(cls, expression, page, per_page):
        ids, total = query_index(cls.__tablename__, expression, page, per_page)
        if total == 0:
            return DB.session.query(cls).filter_by(id=0), 0
        when = []
        for i in range(len(ids)):
            when.append((ids[i], i))
        return DB.session.query(cls).filter(cls.id.in_(ids)).order_by(
            DB.case(when, value=cls.id)), total

    @classmethod
    def reindex(cls):
        counter = 0
        for obj in DB.session.query(cls).all():
            counter += 1
            add_to_index(cls.__tablename__, obj)
        logging.info(f"TOTAL REINDEXED FILES {counter}")

